/*
 ******************************* Creazione file *******************************
 *-------------------------------------|--------------------------------------*
 * Creatore : Marco Savegnago             	Data di creazione : 23/12/98
 * Codice   :
 *
 * Declarations of Message Queue Object
 *
 ******************************* Revisione file *******************************
 *-------------------------------------|--------------------------------------*
 * Revisore : 								Data di revisione :
 * Versione :
 *
 * Note:
 *
 */

#ifndef	__MSGQUEUE_H
#define	__MSGQUEUE_H

/******************************** Definizioni *********************************
*--------------------------------------|--------------------------------------*/

/*************************** Dichiarazione dei tipi ***************************
*--------------------------------------|--------------------------------------*/
/********************************** Inlines ***********************************
*--------------------------------------|--------------------------------------*/

struct	TMSGQueue 
:
	private TSync
{
	HWND		hWindow;
	MSG*		msgs;

	DWORD		dw_limit;
	DWORD		dw_head;
	DWORD		dw_tail;

	UINT		dw_minMessage;
	UINT		dw_maxMessage;
	BOOL		b_running;

	TMSGQueue*	next;

	TMSGQueue(HWND	hWnd,	DWORD	dw_MinMsg,	DWORD	dw_MaxMsg,	DWORD	dw_Size, BOOL	b_start);
	~TMSGQueue();

	bool	Insert(const	MSG& msg);
	bool	Remove(MSG& msg, BOOL	b_Remove);
	bool	IsValidWindow(HWND hWnd);
	bool	IsValidMessage(UINT Message);
	BOOL	IsRunning();
	void	Flush();
	int		IsEmpty();
	int		IsFull();
	int		GetCount();
};

/********************************** Inlines ***********************************
*--------------------------------------|--------------------------------------*/

inline	BOOL	TMSGQueue::IsRunning()
{
	return	b_running;
}

inline	void	TMSGQueue::Flush()
{
	dw_head = 0; 
	dw_tail = 0;
}

inline	int		TMSGQueue::IsEmpty()
{
	TLock lock(this);

	return dw_head == dw_tail;
}

inline	int		TMSGQueue::IsFull()
{
	TLock lock(this);

	return (dw_head == ((dw_tail == 0) ? (dw_limit - 1) : (dw_tail - 1)));
}

inline	int		TMSGQueue::GetCount()
{
	TLock lock(this);

	return (dw_head>=dw_tail) ? (dw_head-dw_tail) : (dw_limit - (dw_tail - dw_head));
}

/************************* Variabili globali esterne **************************
*--------------------------------------|--------------------------------------*/

/************************** Prototipi delle funzioni **************************
*--------------------------------------|--------------------------------------*/

/*********************************** Macro ************************************
*--------------------------------------|--------------------------------------*/

#endif	//	#define	__MSGQUEUE_H
